﻿using System;
using System.Collections.ObjectModel;

namespace XamDataGridTester
{
    public class MainViewModel : BaseViewModel
    {
        public MainViewModel()
        {
            GenerateTestData();
        }

        public ObservableCollection<TestData> Items
        {
            get { return _Items; }
            set { _Items = value; OnPropertyChanged("Items"); }
        }
        private ObservableCollection<TestData> _Items;

        private void GenerateTestData()
        {
            Items = new ObservableCollection<TestData>();

            for (int i = 0; i < 100; i++)
            {
                Items.Add(new TestData()
                {
                    Number = i,
                    Text = new ActiveItem<string>() { Data = "Test item " + (100 + i).ToString(), HasError = (i % 2 == 0) },
                    Real = new ActiveItem<double>() { Data = 11 * i, HasError = (i % 3 == 0) },
                    Date = new ActiveItem<DateTime>() { Data = new DateTime(1910 + i, 1, 1), HasError = (i % 10 == 0) }
                });
            }
        }

        public class ActiveItem<T>
        {
            public T Data { get; set; }
            public bool HasError { get; set; }
        }
        public class TestData
        {
            public int Number { get; set; }
            public ActiveItem<string> Text { get; set; }
            public ActiveItem<double> Real { get; set; }
            public ActiveItem<DateTime> Date { get; set; }
        }
    }
}
